Subject: Re: MIT Kfw SDK w/ Cygwin? Trying to build OpenSSH w/ GSS-API on Cygwin...
From: Nicolas Williams <[email-masked]>
To: Danilo Almeida <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Thu, 3 Jan 2002 15:17:56 -0500

Ah, yes, this is what I was hoping for.

What I have, so far, links, and the resulting ssh.exe even runs, but
then it crashes, around the code that calls GSS-API. I'm trying to trace
it with gdb now.

Also, Kfw should have no need to access stdio, another way in which
cygwin1.dll and msvcrt.dll could interact badly - OpenSSH w/ GSS does
not need krb5_read_password() or krb5_get_init_creds_password() and the
posix prompter function.

Nico

On Thu, Jan 03, 2002 at 03:00:32PM -0500, Danilo Almeida wrote:
> Nico,
> 
> Mixing CRTs can work.  It depends on whether the code in question does not
> expose CRT APIs.  In general, krb5 tends to be pretty good about it...or at
> least, I have tried to clean up some of the problems in that area.  (On
> Windows, you might have a krb5 dll using the debug CRT while the app uses a
> non-debug CRT.)
> 
> If the OpenSSH code is misusing the gssapi (i.e., using free directly
> instead of calling apropriate gssapi routines), then you'll have problems.
> Otherwise, I tend to think that you should generally be ok.  The KfW code
> will use MSVCRT while the OpenSSH code uses cygwin.  Since each is
> encapsulated in separate DLLs, they can call same-name CRT functions from
> different DLLs w/o any problems.  Again, the problem happens if MSVCRT
> allocated memory (opens a file, whatever) and cygwin tries to deallocate (or
> use the file handle opened by MSVCRT, etc).  That should not happen with
> well-designed APIs that do not use CRT abstractions in the API.
> 
> - Danilio
--
-DISCLAIMER: an automatically appended disclaimer may follow. By posting-
-to a public e-mail mailing list I hereby grant permission to distribute-
-and copy this message.-

Visit our website at http://www.ubswarburg.com

This message contains confidential information and is intended only 
for the individual named.  If you are not the named addressee you 
should not disseminate, distribute or copy this e-mail.  Please 
notify the sender immediately by e-mail if you have received this 
e-mail by mistake and delete this e-mail from your system.

E-mail transmission cannot be guaranteed to be secure or error-free 
as information could be intercepted, corrupted, lost, destroyed, 
arrive late or incomplete, or contain viruses.  The sender therefore 
does not accept liability for any errors or omissions in the contents 
of this message which arise as a result of e-mail transmission.  If 
verification is required please request a hard-copy version.  This 
message is provided for informational purposes and should not be 
construed as a solicitation or offer to buy or sell any securities or 
related financial instruments.

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Bug reporting:         http://cygwin.com/bugs.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/